// -*- C++ -*-
// -------------------------------------------------------------------
// MAdLib - Copyright (C) 2008-2009 Universite catholique de Louvain
//
// See the Copyright.txt and License.txt files for license information. 
// You should have received a copy of these files along with MAdLib. 
// If not, see <http://www.madlib.be/license/>
//
// Please report all bugs and problems to <contrib@madlib.be>
//
// Authors: Gaetan Compere, Jean-Francois Remacle
// -------------------------------------------------------------------

#include <sys/time.h>

#ifdef PARALLEL
#include "mpi.h"
#endif

namespace MAd {

  // ----------------------------------------------------------------------
  double CPUTime() {
  
#ifdef PARALLEL
    return MPI_Wtime();
#else
    struct timeval tp;
    struct timezone tz;

    gettimeofday(&tp,&tz);

    return ((double) tp.tv_sec +
            (double) ((double) .000001 * (double) tp.tv_usec));
#endif
  }

  // ----------------------------------------------------------------------

}

